var load_fail_count = 0;

defineVirtualDevice("load_control", {
    title: "Load Control",
    cells: {
        L2: {
            type: "switch",
            value: false
        },
        L3: {
            type: "switch",
            value: false
        },
        load1_fail: {
            type: "switch",
            value: false
        },
        load2_fail: {
            type: "switch",
            value: false
        },
        load3_fail: {
            type: "switch",
            value: false
        }
    }
});

defineRule("L1_fail", {
    whenChanged: "wb-mr3_56/Input 1",
    then: function(newValue, devName, cellName) {
        dev["load_control"]["load1_fail"] = !newValue;
    }
});

defineRule("L2_fail", {
    whenChanged: "wb-mr3_56/Input 2",
    then: function(newValue, devName, cellName) {
        dev["load_control"]["load2_fail"] = !newValue;
    }
});

defineRule("L3_fail", {
    whenChanged: "wb-mr3_56/Input 3",
    then: function(newValue, devName, cellName) {
        dev["load_control"]["load3_fail"] = !newValue;
    }
});

defineRule("loadfail_1", {
    whenChanged: "load_control/load1_fail",
    then: function(newValue, devName, cellName) {
        if (newValue) {
            runShellCommand("python /fail.py");
            dev["button_light"]["blink2"] = 0;
            dev["load_control"]["L2"] = 0;
            dev["button_light"]["blink3"] = 0;
            dev["load_control"]["L3"] = 0;
        }
    }
});

defineRule("loadfail_2", {
    whenChanged: "load_control/load2_fail",
    then: function(newValue, devName, cellName) {
        if (newValue) {
            if (!dev["load_control"]["load1_fail"]) {
                dev["button_light"]["blink2"] = 1;
                dev["load_control"]["L2"] = 0;
            }
        } else {
            dev["button_light"]["blink2"] = 0;
        }
    }
});

defineRule("loadfail_3", {
    whenChanged: "load_control/load3_fail",
    then: function(newValue, devName, cellName) {
        if (newValue) {
            if (!dev["load_control"]["load1_fail"]) {
                dev["button_light"]["blink3"] = 1;
                dev["load_control"]["L3"] = 0;
            }
        } else {
            dev["button_light"]["blink3"] = 0;
        }
    }
});

defineRule("L2_control", {
    whenChanged: "load_control/L2",
    then: function(newValue, devName, cellName) {
        dev["wb-mr3_56"]["K2"] = newValue;
        dev["button_light"]["button2"] = newValue;
    }
});

defineRule("L3_control", {
    whenChanged: "load_control/L3",
    then: function(newValue, devName, cellName) {
        dev["wb-mr3_56"]["K3"] = newValue;
        dev["button_light"]["button3"] = newValue;
    }
});


defineRule("L2_button_control", {
    whenChanged: "wb-gpio/MOD1_IN2",
    then: function(newValue, devName, cellName) {
        if (newValue) {
            dev["load_control"]["L2"] = !dev["load_control"]["L2"];
        }
    }
});

defineRule("L3_button_control", {
    whenChanged: "wb-gpio/MOD1_IN3",
    then: function(newValue, devName, cellName) {
        if (newValue) {
            dev["load_control"]["L3"] = !dev["load_control"]["L3"];
        }
    }
});

defineRule("L2_fail_detect", {
    whenChanged: "wb-map12h_23/Ch 1 P L2",
    then: function(newValue, devName, cellName) {
        dev["wb-gpio"]["EXT1_R3A7"] = newValue >= 1;
        if (newValue > 17) {
            load_fail_count++
            log(load_fail_count);
            if (load_fail_count >= 3) {
                dev["load_control"]["L2"] = 0;
                load_fail_count = 0;
            }
        }
    }
});

defineRule("L3_on", {
    whenChanged: "wb-map12h_23/Ch 1 P L3",
    then: function(newValue, devName, cellName) {
        dev["wb-gpio"]["EXT1_R3A8"] = newValue > 0.5;
    }
});