defineVirtualDevice("water_control", {
    title: "Water Control",
    cells: {
     	valve: {
            type: "switch",
            value: false
        },
      	reset_fail: {
            type: "switch",
            value: false
        },
    }
});

defineRule("water_alarm_control", {
    whenChanged: "wb-mwac_68/Alarm",
    then: function(newValue, devName, cellName) {
      dev["button_light"]["blink1"] = newValue;
      dev["wb-gpio"]["EXT1_R3A6"] = newValue;
      dev["fail_control"]["water_fail"] = newValue;
      if(newValue){
        dev["water_control"]["valve"] = 0;
      }
    }
});

defineRule("water_control", {
    whenChanged: "water_control/valve",
    then: function(newValue, devName, cellName) {
        dev["wb-mwac_68"]["K1"] = newValue;
      	dev["wb-mwac_68"]["K2"] = newValue;
      	dev["button_light"]["button1"] = newValue;
    }
});

defineRule("water_fail_control", {
    whenChanged: "water_control/reset_fail",
    then: function(newValue, devName, cellName) {
      if(newValue){
        dev["water_control"]["reset_fail"] = 0;
        dev["wb-mwac_68"]["Alarm"] = 0;      
      }
    }
});

defineRule("water_button_control", {
    whenChanged: "wb-gpio/MOD1_IN1",
    then: function(newValue, devName, cellName) {
      if(newValue){
        if(dev["wb-mwac_68"]["Alarm"]){
          dev["water_control"]["reset_fail"] = 1;
        }else{
          dev["water_control"]["valve"] = !dev["water_control"]["valve"];
        }
      }
    }
});